unit usbwriter;
//
// USB Flash Memory Writer Control Program
//   Programmed By M.yanagisawa(MoroboshiLUM)  All rights reserved.
//   Copyright(c) 1999 by M.yanagisawa.
//
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SetupApi,usbdi,usb100,usbioctl, StdCtrls, ComCtrls, Menus,WriterDefs,Registry;

type
  // ]obt@(for 32MBit)
  ByteArray = array [0..$3FFFFF] of Byte;
  PByteArray = ^ByteArray;
  
  TVoltage = (_3V,_5V);

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    R1: TMenuItem;
    D1: TMenuItem;
    AutoDevType: TMenuItem;
    BPV: TMenuItem;
    N2: TMenuItem;
    BlankRom: TMenuItem;
    ProgramRom: TMenuItem;
    VerifyRom: TMenuItem;
    Help1: TMenuItem;
    LoadFile: TMenuItem;
    N4: TMenuItem;
    Exit1: TMenuItem;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    N5: TMenuItem;
    ClearMem: TMenuItem;
    ReadRom: TMenuItem;
    SaveFile: TMenuItem;
    DevInfo: TMenuItem;
    Label1: TLabel;
    DevCheck: TMenuItem;
    N1: TMenuItem;
    EraseRom: TMenuItem;
    OptimizeWrite: TMenuItem;
    N3: TMenuItem;
    BPC: TMenuItem;
    SaveDialog1: TSaveDialog;
    function SetStopAddress(hDev:THandle;StopPos:DWORD):boolean;
    function GetMaxAddr(buf:PByteArray;size:DWORD):DWORD;
    function GetVoltage(hDev:THandle;var voltage:TVoltage):boolean;
    procedure BlankProgramChecksum;
    function ExecInit(hDev:THandle):boolean;
    procedure BlankProgram;
    procedure ExecErase;
    procedure ExecReadRom;
    procedure ExecVerifyRom;
    procedure ClearStatus;
    function OpenHandles(var hDev:THandle;var hRead:THandle;var hWrite:THandle):boolean;
    procedure CloseHandles(var hDev:THandle;var hRead:THandle;var hWrite:THandle);
    function ExecRead(hRead:THandle;stopadr:DWORD;buf:PByteArray):boolean;
    function ExecWrite(hWrite:THandle;stopadr:DWORD):boolean;
    function SetDeviceSize(hDev:THandle):boolean;
    procedure BlankProgramVerify;
    procedure ExecBlankCheck;
    function GetDeviceType(hDev:THandle):boolean;
    function Bin2Mem(TransferFile:string):boolean;
    function writebyte(buf:PByteArray;adrs:longint;dat:byte):boolean;
    function writeaddr(segadr:longint;s:string):boolean;
    procedure UpdateGauge(upd:integer);
    procedure WriteStatus(index:integer;s:string);
    function Hex2Mem(TransferFile:string):boolean;
    function CheckSum(hDev:THandle;var sum:DWORD):boolean;
    function BlankCheck(hDev:THandle;var isOK:boolean):boolean;
    function SectorErase(hDev:THandle;mode:boolean;sadr:WORD):boolean;
    function ChipErase(hdev:THandle;mode:boolean):boolean;
    function SetRomPower(hdev:THandle;OnOff:boolean):boolean;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LoadFileClick(Sender: TObject);
    procedure ClearMemClick(Sender: TObject);
    procedure DevCheckClick(Sender: TObject);
    procedure AutoDevTypeClick(Sender: TObject);
    procedure BPVClick(Sender: TObject);
    procedure BlankRomClick(Sender: TObject);
    procedure ProgramRomClick(Sender: TObject);
    procedure VerifyRomClick(Sender: TObject);
    procedure ReadRomClick(Sender: TObject);
    procedure EraseRomClick(Sender: TObject);
    procedure OptimizeWriteClick(Sender: TObject);
    procedure SaveFileClick(Sender: TObject);
    procedure BPCClick(Sender: TObject);
    procedure Help1Click(Sender: TObject);
  private
    { Private 錾 }
    ProgramAreas,ReadAreas : PByteArray;
    HexFileSize : longint;
    NowSize : longint;
    nowState : longint;
    DeviceSize : integer;
    DeviceMode : integer;
    DeviceName : string;
    DeviceVoltage : TVoltage;
    DeviceSig : byte;  // VOl`
    DeviceMan : byte;  // 
    isSetAutoType : boolean;
    isOptimizeWrite : boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  Inputp,about;
//{$DEFINE DEBUGON}

const
  MODE_A = FALSE;
  MODE_B = TRUE;

// ACSII->Binaryϊ
function convbyte(c1,c2:char):byte;
var
  n : byte;
begin
  n:=0;
  case c1 of
    '0'..'9' : n:=(ord(c1)-ord('0')) SHL 4;
    'A'..'F' : n:=(ord(c1)-ord('A')+$a) SHL 4;
  end;
  case c2 of
    '0'..'9' : n:=n or (ord(c2)-ord('0'));
    'A'..'F' : n:=n or (ord(c2)-ord('A')+$a);
  end;
  Result:=n;
end;

// ZOgx[X擾
function getsegbase(s:string):word;
var
  segt : word;
begin
  segt:=0;
  if s<>'' then begin
  if s[1]=':' then begin
    segt:=(word(convbyte(s[10],s[11])) SHL 8) or word(convbyte(s[12],s[13]));
  end;
  end;
  Result:=segt;
end;

function TForm1.GetMaxAddr(buf:PByteArray;size:DWORD):DWORD;
var
  i : DWORD;
begin
  Result:=$10000;
  for i:=size-1 downto 0 do
    if buf^[i]<>$FF then begin
      Result:=(i and $FF0000)+$10000;
      break;
    end;
end;

// obt@Cg
function TForm1.writebyte(buf:PByteArray;adrs:longint;dat:byte):boolean;
begin
  if adrs>sizeof(buf^) then begin
    MessageDlg(Format('TCY傫܂ :%.08x',[adrs]),mtError,[mbOK],0);
    Result:=FALSE;
  end
  else if (buf^[adrs]<>$FF) then begin
    MessageDlg(Format('AhXĂ܂ :%.08x',[adrs]),mtError,[mbOK],0);
    Result:=FALSE;
  end
  else begin
    buf^[adrs]:=dat;
    Result:=TRUE;
  end;
end;

// foCX̎擾
function GetDeviceString(Man:Byte;Sig:Byte;var size:integer;var voltage:TVoltage):string;
const
  DeviceNum = 25;
  DeviceList : array [1..DeviceNum] of Word = (
    $0459,$045A,
    $0455,$0456,
    $0450,$0453,
    $045C,$045F,
    $0436,$0439,
    $042D,$042E,
    $0428,$042B,
    $0433,$0435,
    $04DA,$045B,
    $98CE,$105B,
    $015B,$0449,
    $9843,$04A4,
    $0120
  );
  DeviceStr  : array [1..DeviceNum] of string = (
    'xm MBM29DL321TD','xm MBM29DL321BD',
    'xm MBM29DL322TD','xm MBM29DL322BD',
    'xm MBM29DL323TD','xm MBM29DL323BD',
    'xm MBM29DL324TD','xm MBM29DL324BD',
    'xm MBM29DL161TD','xm MBM29DL161BD',
    'xm MBM29DL162TD','xm MBM29DL162BD',
    'xm MBM29DL163TD','xm MBM29DL163BD',
    'xm MBM29DL164TD','xm MBM29DL164BD',
    'xm MBM29LV800T','xm MBM29LV800B',
    ' TC58FVB800','mdb uPD29F800L-B',
    'sh TMX29LF800B','xm MBM29LV160B',
    ' TC58FVB160','xm MBM29F040B',
    'AMD AM29F010'
   );
  DeviceSiz  : array [1..DeviceNum] of integer = (
    $400000,$400000,
    $400000,$400000,
    $400000,$400000,
    $400000,$400000,
    $200000,$200000,
    $200000,$200000,
    $200000,$200000,
    $200000,$200000,
    $100000,$100000,
    $100000,$100000,
    $100000,$200000,
    $200000,$80000,
    $20000
  );
  DeviceVol : array [1..DeviceNum] of TVoltage = (
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_3V,
    _3V,_5V,
    _5V
  );
var
  Req : word;
  i : integer;
begin
  Result:=''; size:=-1; voltage:=_3V;
  Req:=(Word(Man) SHL 8)+WORD(Sig);
  for i:=1 to DeviceNum do begin
    if Req=DeviceList[i] then begin
      Result:=DeviceStr[i];
      size:=DeviceSiz[i];
      voltage:=DeviceVol[i];
      break;
    end;
  end;
end;

function TForm1.writeaddr(segadr:longint;s:string):boolean;
var
  c : byte;
  sum : byte;
  n : word;
  i,max,j : integer;
  wptrtmp : longint;
  err : boolean;
begin
  Result:=TRUE; err:=FALSE; sum:=0;
  if s='' then
  exit;
  if s[1]=':' then begin
    { sȃf[^폜 }
    for i:=2 to Length(s) do begin
      if s[i] in ['A'..'F','0'..'9'] then else err:=TRUE;
    end;
    if Length(s)<12 then err:=TRUE;
    max:=convbyte(s[2],s[3]);
    if Length(s)<>(max*2)+11 then err:=TRUE;
    if not err then begin
      n:=(word(convbyte(s[4],s[5])) SHL 8) or word(convbyte(s[6],s[7]));
      wptrtmp:=longint(n)+segadr;
      j:=2;
      { calc sum 5bytes }
      for i:=1 to 4 do begin
        sum:=sum+convbyte(s[j],s[j+1]);
        inc(j,2);
      end;
      for i:=1 to max do begin
        c:=convbyte(s[j],s[j+1]);
        sum:=sum+c;
        if not writebyte(ProgramAreas,wptrtmp,c) then begin
          Result:=FALSE;
          exit;
        end;
        inc(wptrtmp); inc(j,2);
      end;
      c:=convbyte(s[j],s[j+1]);
      if byte(0-integer(sum))<>c then err:=TRUE;
    end;
    if err then begin
      MessageDlg('ُȃt@Cł.',mtWarning,[mbOK],0);
      Result:=FALSE;
   end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm1.UpdateGauge(upd:integer);
begin
  WriteStatus(0,'Loading.. :'+IntToStr(upd)+'%');
  ProgressBar1.Position:=upd;
end;

////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm1.WriteStatus(index:integer;s:string);
begin
  StatusBar1.Panels[index].Text:=s;
end;

// INTEL-32wLTt@C[֓WJB
function TForm1.Hex2Mem(TransferFile:string):boolean;
var
  ratio : integer;
  f : TextFile;
  s: string;
  segadr : longint;   (* ޕAhX *)
  realadr : longint;
  baseofs : longint;
begin
  Result:=TRUE;  NowSize:=0; baseofs:=0; nowstate:=-1;
  Screen.Cursor:=crHourGlass;
  assignFile(f,TransferFile);
  FileMode:=0;
  {$I-} reset(f); {$I+}
  if ioresult=0 then begin
    FillChar(ProgramAreas^,sizeof(ProgramAreas^),$FF);  // ALL CLEAR!!
    segadr:=0; realadr:=baseofs; // NA
    while not eof(f) do begin
      readln(f,s);
      NowSize:=Nowsize+longint(Length(s)+2);
      ratio:=(NowSize * 100) div HexFileSize;
      if ratio <> nowState then begin
         UpdateGauge(ratio);
         nowState:=ratio;
         Application.ProcessMessages;
      end;
      if pos(':02000002',s)=1 then begin
        segadr:=longint(getsegbase(s))*16;
      end
      else if pos(':02000004',s)=1 then begin
        realadr:=longint(getsegbase(s))*$10000;
      end
      else if pos(':04000003',s)=1 then begin
        Screen.Cursor:=crDefault;
        MessageDlg('gAhXR[h̓T|[gĂ܂.',mtError,[mbOK],0);
        closefile(f);
        Result:=FALSE;
        exit;
      end
      else if pos(':00000001FF',s)=1 then begin
        UpdateGauge(100);
        break;
      end
      else begin
        if not writeaddr(segadr+realadr,s) then begin
          Screen.Cursor:=crDefault;
          Result:=FALSE;
          closefile(f);
          exit;
        end;
      end;
    end;
    closefile(f);
  end
  else begin
    Screen.Cursor:=crDefault;
    MessageDlg('t@CJ܂.',mtError,[mbOK],0);
    Result:=FALSE;
  end;
  Screen.Cursor:=crDefault;
end;

// ȃoCit@C̓ǂݍ
function TForm1.Bin2Mem(TransferFile:string):boolean;
var
  n,ratio : integer;
  f : File;
  buf : array [0..4095] of byte;
  ofs,readsize : longint;
begin
  Result:=TRUE;  NowSize:=0;  nowState:=-1;
  Screen.Cursor:=crHourGlass;
  assignFile(f,TransferFile);
  FileMode:=0;
  {$I-} reset(f,1); {$I+}
  if ioresult=0 then begin
    FillChar(ProgramAreas^,sizeof(ProgramAreas^),$FF);  // ALL CLEAR!!
    ofs:=0;
    repeat
      BlockRead(f,buf,sizeof(buf),readsize);
      for n:=1 to readsize do begin
        if not writebyte(ProgramAreas,ofs,buf[n-1]) then begin
          CloseFile(f);
          Result:=FALSE;
          exit;
        end;
        inc(ofs);
      end;
      NowSize:=Nowsize+readsize;
      ratio:=(NowSize * 100) div HexFileSize;
      if ratio <> nowState then begin
         UpdateGauge(ratio);
         nowState:=ratio;
         Application.ProcessMessages;
      end;
    until readsize<>sizeof(buf);
    UpdateGauge(100);
    closefile(f);
  end
  else begin
    Screen.Cursor:=crDefault;
    MessageDlg('t@CJ܂.',mtError,[mbOK],0);
    Result:=FALSE;
  end;
  Screen.Cursor:=crDefault;
end;


// foCX̃I[vBPnPƃfoCX擾A֌WUSB_DEVICE_DESCRIPTER
// ݒ肵܂B
function OpenOneDevice (HardwareDeviceInfo:HDEVINFO;
    DeviceInfoData:PSP_INTERFACE_DEVICE_DATA;
    devName:PChar
    ):THANDLE;
{$IFNDEF DEBUGON}
var
    functionClassDeviceData : PSP_INTERFACE_DEVICE_DETAIL_DATA;
    predictedLength : ULONG;
    requiredLength : ULONG;
    hOut : THANDLE;
begin
    hOut := INVALID_HANDLE_VALUE;
    functionClassDeviceData := NIL;
    predictedLength := 0;
    requiredLength := 0;

    // ̧ݸ݃NXfoCXf[^󂯎obt@m
    SetupDiGetDeviceInterfaceDetail(HardwareDeviceInfo,DeviceInfoData,NIL,0,@requiredLength,NIL);

    predictedLength := requiredLength;
    // sizeof (SP_FNCLASS_DEVICE_DATA) + 512;

    GetMem(functionClassDeviceData,predictedLength);
    functionClassDeviceData.cbSize := sizeof(TSP_INTERFACE_DEVICE_DETAIL_DATA);
    // PnP擾B
    if not SetupDiGetDeviceInterfaceDetail(HardwareDeviceInfo,DeviceInfoData,
               functionClassDeviceData,predictedLength,@requiredLength,NIL) then begin
      Result:=INVALID_HANDLE_VALUE;
      exit;
    end;
    strcopy( devName,functionClassDeviceData.DevicePath) ;
    hOut := CreateFile (functionClassDeviceData.DevicePath,
      GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,NIL,OPEN_EXISTING,0,0);
    if (INVALID_HANDLE_VALUE = hOut) then begin
      MessageDlg(Format('foCX̃I[vɎs܂ (%s)', [devName]),mtError,[mbOK],0);
    end;
    result:=hOut;
end;
{$ELSE}
begin
end;
{$ENDIF}


// Ăяo_œKȃfoCX邽߂PnP܂B
function OpenUsbDevice(pGuid:PGUID; outNameBuf:PChar):THANDLE;
{$IFNDEF DEBUGON}
var
   NumberDevices: ULONG;
   hOut : THANDLE;
   hardwareDeviceInfo: HDEVINFO;
   deviceinfoData : SP_INTERFACE_DEVICE_DATA;
   i : ULONG;
   done : boolean;
   usbDeviceInst : PUSB_DEVICE_DESCRIPTOR;
   UsbDevices : ^PUSB_DEVICE_DESCRIPTOR;

begin
   UsbDevices:=@usbDeviceInst;
   UsbDevices^ := NIL;
   NumberDevices := 0;
   hOut:=INVALID_HANDLE_VALUE;

   // oofoCX[hŃnhJ܂B
   // SetupDiGetClassDevs͓̃NX̃CXg[ꂽfoCX̏Ԃ܂B
   hardwareDeviceInfo:=SetupDiGetClassDevs(pGuid,NIL,0,(DIGCF_PRESENT or DIGCF_INTERFACEDEVICE));

   // 芸KɃfoCX߂ĊJ܂BsA܂₵ăgCB
   NumberDevices := 4;
   done := FALSE;
   deviceInfoData.cbSize := sizeof (SP_INTERFACE_DEVICE_DATA);
   i:=0;
   while (not done) do begin
      NumberDevices := NumberDevices * 2;
      if (UsbDevices^<>NIL) then begin
         ReallocMem(UsbDevices^, (NumberDevices * sizeof(TUSB_DEVICE_DESCRIPTOR)));
      end
      else begin
         GetMem(UsbDevices^,NumberDevices * sizeof (TUSB_DEVICE_DESCRIPTOR));
      end;
      if (NIL = UsbDevices^) then begin
         // Ȃ΃n[hEFAjďI
         SetupDiDestroyDeviceInfoList(hardwareDeviceInfo);
         Result:=INVALID_HANDLE_VALUE;
         exit;
      end;
      usbDeviceInst:= PUSB_DEVICE_DESCRIPTOR(DWORD(UsbDevices^) + i);
      while (i<NumberDevices) do begin
        if SetupDiEnumDeviceInterfaces (hardwareDeviceInfo,NIL,pGuid,i,@deviceInfoData) then begin
          hOut := OpenOneDevice (hardwareDeviceInfo, @deviceInfoData, outNameBuf);
          if ( hOut <> INVALID_HANDLE_VALUE ) then begin
            done := TRUE;
            break;
          end;
        end
        else begin
          if (ERROR_NO_MORE_ITEMS = GetLastError()) then begin
            done := TRUE;
            break;
          end;
        end;
        inc(i);
      end;
   end;
   NumberDevices := i;
   SetupDiDestroyDeviceInfoList (hardwareDeviceInfo);
   Result:=hOut;
end;
{$ELSE}
begin
end;
{$ENDIF}

function TForm1.SetRomPower(hdev:THandle;OnOff:boolean):boolean;
var
  dmy : DWORD;
  HR : boolean;
begin
  HR:=DeviceIoControl(hdev,IOCTL_FLASHWR_ROMPOWER,@OnOff,1,NIL,0,dmy,NIL);
  Result:=HR;
  if not HR then
    MessageDlg('qnldɎs܂.',mtError,[mbOK],0);
end;

function TForm1.ChipErase(hDev:THandle;mode:boolean):boolean;
var
  HR : boolean;
  dmy : DWORD;
  buff : array [0..255] of Byte;
begin
  Result:=FALSE;  // default = FALSE
  StatusBar1.Panels[0].Text:='`bvł.';
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_CHIPERASE,@mode,1,NIL,0,dmy,NIL);
  if HR then begin
    while TRUE do begin
      HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
      if not HR then break;
      Application.ProcessMessages;
      if (buff[0] and $80)<>0 then begin
        Result:=buff[2]=0;
        if buff[2]=0 then Result:=TRUE
                     else HR:=FALSE;
        break;
      end;
    end;
  end;
  if not HR then
    MessageDlg('`bvɎs܂.',mtError,[mbOK],0);
end;

function TForm1.CheckSum(hDev:THandle;var Sum:DWORD):boolean;
type
  dwordptr = ^DWORD;
var
  HR : boolean;
  dmy : DWORD;
  buff : array [0..255] of Byte;
begin
  Result:=FALSE;  // default = FALSE
  sum:=0;
  StatusBar1.Panels[0].Text:='ROM`FbNTvZł.';
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_CHECKSUM,NIL,0,NIL,0,dmy,NIL);
  if HR then begin
    while TRUE do begin
      HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
      if not HR then break;
      Application.ProcessMessages;
      if (buff[0] and $80)<>0 then begin
        sum:=DWORDPTR(@buff[2])^;
        Result:=TRUE;
        break;
      end;
    end;
  end;
  if not HR then
    MessageDlg('`FbNT̎擾Ɏs܂.',mtError,[mbOK],0);
end;

function TForm1.BlankCheck(hDev:THandle;var isOk:boolean):boolean;
var
  HR : boolean;
  dmy : DWORD;
  buff : array [0..255] of Byte;
begin
  Result:=FALSE;  // default = FALSE
  isOk:=FALSE;
  StatusBar1.Panels[0].Text:='uN`FbNł.';
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_BLANK,NIL,0,NIL,0,dmy,NIL);
  if HR then begin
    while TRUE do begin
      HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
      if not HR then break;
      Application.ProcessMessages;
      if (buff[0] and $80)<>0 then begin
        isOk:=buff[2]=0;
        Result:=TRUE;
        break;
      end;
    end;
  end;
  if not HR then
    MessageDlg('uN`FbNɎs܂.',mtError,[mbOK],0);
end;

function TForm1.SectorErase(hDev:THandle;mode:boolean;sadr:WORD):boolean;
type
  wordptr = ^word;
var
  HR : boolean;
  dmy : DWORD;
  buff : array [0..255] of Byte;
begin
  Result:=FALSE;  // Default = FALSE
  buff[0]:=BYTE(mode);
  wordptr(@buff[1])^:=sadr;
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_SECTORERASE,@buff,3,NIL,0,dmy,NIL);
  if HR then begin
    while TRUE do begin
      HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
      if not HR then break;
      Application.ProcessMessages;
      if (buff[0] and $80)<>0 then begin
        Result:=buff[2]=0;
        if buff[2]=0 then showmessage('ok')
                     else showmessage('ng');
        break;
      end;
    end;
  end;
end;

// foCXnhƓǂݏp̃pCvJ
function TForm1.OpenHandles(var hDev:THandle;var hRead:THandle;var hWrite:THandle):boolean;
var
 buf,buf2 : array [0..1024] of char;
begin
  Result:=FALSE;
  hDev:=INVALID_HANDLE_VALUE;  hRead:=INVALID_HANDLE_VALUE;  hWrite:=INVALID_HANDLE_VALUE;
  hDev:=OpenUsbDevice(@WRITER_GUID,buf);
  if hDev<>INVALID_HANDLE_VALUE then begin
    strcopy(buf2,buf);
    strcat(buf,'\PIPE00');
    strcat(buf2,'\PIPE01');
    hRead:=CreateFile(buf2,GENERIC_WRITE or GENERIC_READ,FILE_SHARE_WRITE or FILE_SHARE_READ,NIL,OPEN_EXISTING,0,0);
    hWrite:=CreateFile(buf,GENERIC_WRITE or GENERIC_READ,FILE_SHARE_WRITE or FILE_SHARE_READ,NIL,OPEN_EXISTING,0,0);
    if (hWrite<>INVALID_HANDLE_VALUE) and (hRead<>INVALID_HANDLE_VALUE) then Result:=TRUE;
  end;
end;

// SnhN[Y
procedure TForm1.CloseHandles(var hDev:THandle;var hRead:THandle;var hWrite:THandle);
begin
  if hRead<>INVALID_HANDLE_VALUE then CloseHandle(hRead);
  if hWrite<>INVALID_HANDLE_VALUE then CloseHandle(hWrite);
  if hDev<>INVALID_HANDLE_VALUE then CloseHandle(hDev);
  hDev:=INVALID_HANDLE_VALUE;  hRead:=INVALID_HANDLE_VALUE;  hWrite:=INVALID_HANDLE_VALUE;
end;


function TForm1.ExecRead(hRead:THandle;stopadr:DWORD;buf:PByteArray):boolean;
var
  all,dmy,i : DWORD;
  prev,n,ofs : integer;
  buff : array [0..1023] of byte;
begin
  Result:=FALSE;
  all:=0; prev:=-1; ofs:=0;
  while (all<stopadr) do begin
    if not ReadFile(hRead,buff,sizeof(buff),dmy,NIL) then begin
      MessageDlg('ǂݍ݂Ɏs܂.',mtError,[mbOK],0);
      exit;
    end;
    for i:=1 to dmy do begin
      writebyte(buf,ofs,buff[i-1]);
      inc(ofs);
    end;
    all:=all+dmy;
    n:=(all * 100) div stopadr;
    if n<>prev then begin
      StatusBar1.Panels[0].Text:='ǂݍݒł: '+IntToStr(n)+'%';
      ProgressBar1.Position:=n;
      prev:=n;
      Application.ProcessMessages;
    end;
  end;
  Result:=TRUE;
end;

function TForm1.ExecWrite(hWrite:THandle;stopadr:DWORD):boolean;
var
  dmy,all : DWORD;
  prev,n : integer;
  buff : array [0..1023] of byte;
begin
  Result:=FALSE;
  all:=0; prev:=-1;
  while (all<stopadr) do begin
    Move(ProgramAreas^[all],buff,sizeof(buff));   // 64 byteP
    if not WriteFile(hWrite,buff,sizeof(buff),dmy,NIL) then begin
      MessageDlg('݂Ɏs܂.',mtError,[mbOK],0);
      exit;
    end;
    all:=all+dmy;
    n:=(all * 100) div stopadr;
    if n<>prev then begin
      StatusBar1.Panels[0].Text:='ݒł: '+IntToStr(n)+'%';
      ProgressBar1.Position:=n;
      prev:=n;
      Application.ProcessMessages;
    end;
  end;
  Result:=TRUE;
end;

// ݐݒ肳ĂdԂB voltage=TRUÊƂ3.3V[h
function TForm1.GetVoltage(hDev:THandle;var voltage:TVoltage):boolean;
var
  HR : boolean;
  buff : array [0..255] of byte;
  dmy : DWORD;
begin
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
  if HR then begin
          if (buff[1] and $20)<>0 then voltage:=_3V
                                  else voltage:=_5V;
        end
        else begin
          voltage:=_3V;
          MessageDlg('{[h̓d擾ł܂.',mtError,[mbOK],0);
        end;
  Result:=HR;
end;

// foCXTCY̐ݒ
function TForm1.SetDeviceSize(hDev:THandle):boolean;
var
  s:string;
  mr : TModalResult;
  frm: TInputProparty;
  size : integer;
begin
  if isSetAutoType then
    if not GetDeviceType(hDev) then ;
  if DeviceSize<0 then begin
    MessageDlg('foCXTCYݒ肳Ă܂.',mtError,[mbOK],0);
    frm:=TInputProparty.Create(Self);
    with frm do begin
      LowVoltage.Checked:=DeviceVoltage=_3V;
      WordChip.Checked:=DeviceMode=0;
      mr:=ShowModal;
      if mr=mrOK then begin
        if LowVoltage.Checked then DeviceVoltage:=_3V
                              else DeviceVoltage:=_5V;
        if WordChip.Checked then DeviceMode:=0
                            else DeviceMode:=1;
        try
          size:=StrToInt('$'+SizeEdit.Text) and $FF0000;
          if size<=0 then EConvertError.Create('');
        except
          mr:=mrCancel;
          MessageDlg('w肳ꂽTCY͖ł.',mtError,[mbOK],0);
        end;
      end;
      if mr=mrOK then begin
         DeviceSize:=size;
         s:=Format('s  =$%X, d=',[size]);
         if DeviceVoltage=_3V then s:=s+'3.3V'
                              else s:=s+'5.0V';
         StatusBar1.Panels[1].Text:=s;
      end
      else DeviceSize:=-1;
    end;
    frm.free;
  end;
  Result:=DeviceSize>0;
end;

// uNEvOExt@C
procedure TForm1.BlankProgramVerify;
var
  HR,isDisped : boolean;
  isBlank : boolean;
  prev,n,i : integer;
  sum,sum2,max : DWORD;
  mode : boolean;
  hDev,hRead,hWrite : THandle;
  dmy : DWORD;
  buff : array [0..255] of byte;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    mode:=DeviceMode<>0;    // foCX[hݒ
    if not BlankCheck(hDev,isBlank) then break;
    if not isBlank then begin
      if MessageDlg('uNԂł͂܂Bđs܂?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
        if not ChipErase(hDev,mode) then break;
        if not BlankCheck(hDev,isBlank) then break;
        if not isBlank then begin
          MessageDlg('ł܂.',mtError,[mbOK],0);
          break;
        end;
      end
      else begin
        MessageDlg('݂𒆒f܂.',mtInformation,[mbOK],0);
        break;
      end;
    end;
    if isOptimizeWrite then begin
      max:=GetMaxAddr(ProgramAreas,DeviceSize);
      if not SetStopAddress(hDev,max) then break;
    end
    else
      max:=DeviceSize;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_WRITE,@mode,1,NIL,0,dmy,NIL);
    if HR then begin
      if not ExecWrite(hWrite,max) then break;
    end
    else begin
      MessageDlg('ݗvɎs܂.',mtError,[mbOK],0);
      break;
    end;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
    if ((buff[0] and $80)<>0) and HR  then
    else begin
      MessageDlg('݂Ɏs܂.',mtError,[mbOK],0);
      break;
    end;
    // ǂݏo͂ƎsB
    if isOptimizeWrite then
      if not SetStopAddress(hDev,DeviceSize) then break;    // AhXĐݒ
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_READ,NIL,0,NIL,0,dmy,NIL);
    if HR then begin
      if not ExecRead(hRead,DeviceSize,ReadAreas) then break;
    end
    else begin
      MessageDlg('ǂݏovɎs܂.',mtError,[mbOK],0);
      break;
    end;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
    if ((buff[0] and $80)<>0) and HR then begin
      prev:=-1; i:=0; sum:=0; isDisped:=FALSE; sum2:=0;
      while i<DeviceSize do begin
        if (ReadAreas^[i]<>ProgramAreas^[i]) and (not IsDisped) then begin
          MessageDlg('lقȂ܂.',mtError,[mbOK],0);
          isDisped:=TRUE;
        end;
        n:=(i * 100) div DeviceSize;
        if n<>prev then begin
          StatusBar1.Panels[0].Text:='rł: '+IntToStr(n)+'%';
          ProgressBar1.Position:=n;
          prev:=n;
          Application.ProcessMessages;
        end;
        sum:=sum+ReadAreas^[i];
        sum2:=sum2+ProgramAreas^[i];
        inc(i);
      end; // while
      SetRomPower(hDev,FALSE);
      if not isDisped then
        MessageDlg(Format('ɏ܂܂.'#13'Checksum = %.08X',[sum]),mtInformation,[mbOK],0)
      else
        MessageDlg(Format('݂Ɏs܂.'#13'Rom Checksum = %.08X , Mem Checksum= %.08X',[sum,sum2]),mtInformation,[mbOK],0)
    end
    else begin
      MessageDlg('ǂݏoɎs܂.',mtError,[mbOK],0);
    end;
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;


// uNEvOE`FbNT
procedure TForm1.BlankProgramChecksum;
var
  HR : boolean;
  isBlank : boolean;
  prev,n,i : integer;
  sum,sum2,max : DWORD;
  mode : boolean;
  hDev,hRead,hWrite : THandle;
  dmy : DWORD;
  buff : array [0..255] of byte;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    mode:=DeviceMode<>0;    // foCX[hݒ
    if not BlankCheck(hDev,isBlank) then break;
    if not isBlank then begin
      if MessageDlg('uNԂł͂܂Bđs܂?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
        if not ChipErase(hDev,mode) then break;
        if not BlankCheck(hDev,isBlank) then break;
        if not isBlank then begin
          MessageDlg('ł܂.',mtError,[mbOK],0);
          break;
        end;
      end
      else begin
        MessageDlg('݂𒆒f܂.',mtInformation,[mbOK],0);
        break;
      end;
    end;
    if isOptimizeWrite then begin
      max:=GetMaxAddr(ProgramAreas,DeviceSize);
      if not SetStopAddress(hDev,max) then break;
    end
    else
      max:=DeviceSize;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_WRITE,@mode,1,NIL,0,dmy,NIL);
    if HR then begin
      if not ExecWrite(hWrite,max) then break;
    end
    else begin
      MessageDlg('ݗvɎs܂.',mtError,[mbOK],0);
      break;
    end;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
    if ((buff[0] and $80)<>0) and HR  then
    else begin
      MessageDlg('݂Ɏs܂.',mtError,[mbOK],0);
      break;
    end;
    if isOptimizeWrite then
      if not SetStopAddress(hDev,DeviceSize) then break;    // AhXĐݒ
    if not CheckSum(hDev,sum) then break;   // ROM`FbNT擾
    prev:=-1; i:=0; sum2:=0;
    while i<DeviceSize do begin
      n:=(i * 100) div DeviceSize;
      if n<>prev then begin
        StatusBar1.Panels[0].Text:='`FbNTvZł : '+IntToStr(n)+'%';
        ProgressBar1.Position:=n;
        prev:=n;
        Application.ProcessMessages;
      end;
      sum2:=sum2+ProgramAreas^[i];
      inc(i);
    end; // while
    SetRomPower(hDev,FALSE);
    if sum=sum2 then
      MessageDlg(Format('ɏ܂܂.'#13'Checksum = %.08X',[sum]),mtInformation,[mbOK],0)
    else
      MessageDlg(Format('݂Ɏs܂.'#13'Rom Checksum = %.08X , Mem Checksum= %.08X',[sum,sum2]),mtWarning,[mbOK],0);
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;

// uNEvO
procedure TForm1.BlankProgram;
var
  HR : boolean;
  isBlank : boolean;
  mode : boolean;
  hDev,hRead,hWrite : THandle;
  dmy,max : DWORD;
  buff : array [0..255] of byte;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    mode:=DeviceMode<>0;    // foCX[hݒ
    if not BlankCheck(hDev,isBlank) then break;
    if not isBlank then begin
      if MessageDlg('uNԂł͂܂Bđs܂?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
        if not ChipErase(hDev,mode) then break;
        if not BlankCheck(hDev,isBlank) then break;
        if not isBlank then begin
          MessageDlg('ł܂.',mtError,[mbOK],0);
          break;
        end;
      end
      else begin
        MessageDlg('݂𒆒f܂.',mtInformation,[mbOK],0);
        break;
      end;
    end;
    if isOptimizeWrite then begin
      max:=GetMaxAddr(ProgramAreas,DeviceSize);
      if not SetStopAddress(hDev,max) then break;
    end
    else
      max:=DeviceSize;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_WRITE,@mode,1,NIL,0,dmy,NIL);
    if HR then begin
      if not ExecWrite(hWrite,max) then break;
    end
    else begin
      MessageDlg('ݗvɎs܂.',mtError,[mbOK],0);
      break;
    end;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
    if ((buff[0] and $80)<>0) and HR  then
    else begin
      MessageDlg('݂Ɏs܂.',mtError,[mbOK],0);
      break;
    end;
    SetRomPower(hDev,FALSE);
    MessageDlg('݂܂.',mtError,[mbOK],0);
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;

// uN`FbN
procedure TForm1.ExecBlankCheck;
var
  isBlank : boolean;
  hDev,hRead,hWrite : THandle;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    if not BlankCheck(hDev,isBlank) then break;
    if not isBlank then MessageDlg('uNԂł͂܂.',mtInformation,[mbOK],0)
                   else MessageDlg('uNԂł.',mtInformation,[mbOK],0);
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;

// 
procedure TForm1.ExecErase;
var
  isBlank,mode : boolean;
  hDev,hRead,hWrite : THandle;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    mode:=DeviceMode<>0;
    if not ChipErase(hDev,mode) then break;
    if not BlankCheck(hDev,isBlank) then break;
    SetRomPower(hDev,FALSE);
    if not isBlank then MessageDlg('Ɏs܂.',mtInformation,[mbOK],0)
                   else MessageDlg('܂.',mtInformation,[mbOK],0);
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;

// dIEdԎ擾EfoCXݒ
function TForm1.ExecInit(hDev:THandle):boolean;
var
 dmy : DWORD;
 voltage : TVoltage;
 HR : boolean;
begin
  Result:=FALSE;
  FillChar(ReadAreas^,sizeof(ReadAreas^),$FF);  // ǂݏoobt@
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_INITIALIZE,NIL,0,NIL,0,dmy,NIL);
  if not HR then begin
    MessageDlg('Ɏs܂.',mtError,[mbOK],0);
    exit; //
  end;
  if not SetRomPower(hDev,TRUE) then exit;  // don
  if not SetDeviceSize(hDev) then exit;
  if not GetVoltage(hDev,voltage) then exit;  // dԎ擾
  if voltage<>DeviceVoltage then begin
    MessageDlg('dݒ肪قȂ܂.',mtError,[mbOK],0);
    exit;
  end;
  if not SetStopAddress(hDev,DeviceSize) then exit;
  Result:=TRUE;
end;

// l`wAhXݒ
function TForm1.SetStopAddress(hDev:THandle;StopPos:DWORD):boolean;
var
  stopadr:WORD;
  dmy : DWORD;
  HR : boolean;
begin
  stopadr:=StopPos div $100;
  HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_SETADDRESS,@stopadr,sizeof(stopadr),@stopadr,sizeof(stopadr),dmy,NIL);
  if not HR then begin
    MessageDlg('AhX̐ݒɎs܂.',mtError,[mbOK],0);
  end;
  Result:=HR;
end;

// ǂݏo
procedure TForm1.ExecReadRom;
var
  HR : boolean;
  prev,n,i : integer;
  sum : DWORD;
  hDev,hRead,hWrite : THandle;
  dmy : DWORD;
  buff : array [0..255] of byte;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_READ,NIL,0,NIL,0,dmy,NIL);
    if HR then begin
      if not ExecRead(hRead,DeviceSize,ProgramAreas) then break;
    end
    else begin
      MessageDlg('ǂݏovɎs܂.',mtError,[mbOK],0);
      break;
    end;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
    if ((buff[0] and $80)<>0) and HR then begin
      prev:=-1; i:=0; sum:=0;
      while i<DeviceSize do begin
        n:=(i * 100) div DeviceSize;
        if n<>prev then begin
          StatusBar1.Panels[0].Text:='`FbNTvZł: '+IntToStr(n)+'%';
          ProgressBar1.Position:=n;
          prev:=n;
          Application.ProcessMessages;
        end;
        sum:=sum+ProgramAreas^[i];
        inc(i);
      end; // while
      SetRomPower(hDev,FALSE);
      if i=DeviceSize then
        MessageDlg(Format('ɓǂݏo܂.'#13'Checksum = %.08X',[sum]),mtInformation,[mbOK],0);
    end
    else begin
      MessageDlg('ǂݏoɎs܂.',mtError,[mbOK],0);
    end;
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;

// xt@C
procedure TForm1.ExecVerifyRom;
var
  HR,isDisped : boolean;
  prev,n,i : integer;
  sum,sum2 : DWORD;
  hDev,hRead,hWrite : THandle;
  dmy : DWORD;
  buff : array [0..255] of byte;
begin
  while OpenHandles(hDev,hRead,hWrite) do begin
    if not ExecInit(hDev) then break;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_READ,NIL,0,NIL,0,dmy,NIL);
    if HR then begin
      if not ExecRead(hRead,DeviceSize,ReadAreas) then break;
    end
    else begin
      MessageDlg('ǂݏovɎs܂.',mtError,[mbOK],0);
      break;
    end;
    HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_ENQUIRE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
    if ((buff[0] and $80)<>0) and HR then begin
      prev:=-1; i:=0; sum:=0; isDisped:=FALSE; sum2:=0;
      while i<DeviceSize do begin
        if (ReadAreas^[i]<>ProgramAreas^[i]) and (not IsDisped) then begin
          MessageDlg('lقȂ܂.',mtError,[mbOK],0);
          isDisped:=TRUE;
        end;
        n:=(i * 100) div DeviceSize;
        if n<>prev then begin
          StatusBar1.Panels[0].Text:='rł: '+IntToStr(n)+'%';
          ProgressBar1.Position:=n;
          prev:=n;
          Application.ProcessMessages;
        end;
        sum:=sum+ReadAreas^[i];
        sum2:=sum2+ProgramAreas^[i];
        inc(i);
      end; // while
      SetRomPower(hDev,FALSE);
      if not isDisped then
        MessageDlg(Format('ROMƃev܂.'#13'Checksum = %.08X',[sum]),mtInformation,[mbOK],0)
      else
        MessageDlg(Format('ROMƃeقȂ܂.'#13'Rom Checksum = %.08X , Mem Checksum= %.08X',[sum,sum2]),mtInformation,[mbOK],0)
    end
    else begin
      MessageDlg('ǂݏoɎs܂.',mtError,[mbOK],0);
    end;
    break; // ɁB
  end;
  if hDev<>INVALID_HANDLE_VALUE then SetRomPower(hDev,FALSE);
  CloseHandles(hDev,hRead,hWrite);
end;


procedure TForm1.ClearStatus;
begin
  ProgressBar1.Position:=0;
  StatusBar1.Panels[0].Text:='';
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  ini : TRegIniFile;
begin
  ini:=TRegIniFile.Create('\Myan\USBWriter');
  isSetAutoType:=ini.ReadBool('Config','SetAutoType',TRUE);
  isOptimizeWrite:=ini.ReadBool('Config','OptimizeWrite',TRUE);
  OptimizeWrite.Checked:=isOptimizeWrite;
  AutoDevType.Checked:=isSetAutoType;
  ini.Free;
  DeviceSize:=-1;
  New(ProgramAreas);
  FillChar(ProgramAreas^,sizeof(ProgramAreas^),$FF);
  New(ReadAreas);
  FillChar(ReadAreas^,sizeof(ReadAreas^),$FF);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  ini : TRegIniFile;
begin
  ini:=TRegIniFile.Create('\Myan\USBWriter');
  ini.WriteBool('Config','SetAutoType',AutoDevType.Checked);
  ini.WriteBool('Config','OptimizeWrite',OptimizeWrite.Checked);
  ini.Free;
  Dispose(ProgramAreas);
  Dispose(ReadAreas);
end;

procedure TForm1.LoadFileClick(Sender: TObject);
var
  f : FILE;
  fext : string;
begin
  if OpenDialog1.Execute then begin
    assignFile(f,OpenDialog1.Filename);
    FileMode:=0;
    {$I-} reset(f,1); {$I+};
    if IOResult=0 then begin
      HexFileSize:=filesize(f);
      CloseFile(f);
      fext:=UpperCase(ExtractFileExt(OpenDialog1.FileNAme));
      if fext='.HEX'  then begin  // .HEX̂݁B
        if Hex2Mem(OpenDialog1.FileName) then begin
          MessageDlg('t@Cǂݍ݂܂.',mtInformation,[mbOK],0);
        end;
      end
      else begin
        if Bin2Mem(OpenDialog1.FileName) then begin
          MessageDlg('t@Cǂݍ݂܂.',mtInformation,[mbOK],0);
        end;
      end;
    end
    else begin
      MessageDlg('t@CJ܂.',mtError,[mbOK],0);
    end;
    WriteStatus(0,'');
    ProgressBar1.Position:=0;
  end;
end;

procedure TForm1.SaveFileClick(Sender: TObject);
var
  isOK : TModalResult;
  frm : TInputProparty;
  f : FILE;
  size,saved : DWORD;
begin
  if SaveDialog1.Execute then begin
    frm:=TInputProparty.Create(Self);
    with frm do begin
      if DeviceSize>=0 then SizeEdit.Text:=Format('%X',[DeviceSize]);
      WordChip.Enabled:=FALSE;
      LowVoltage.Enabled:=FALSE;
    end;
    isOk:=frm.ShowModal;
    if isOk=mrOK then begin
      try
        size:=StrToInt('$'+frm.SizeEdit.Text);
        if size<=0 then EConvertError.Create('');
      except
        isOk:=mrCancel;
        MessageDlg('w肳ꂽTCY͖ł.',mtError,[mbOK],0);
      end;
    end;
    frm.free;
    if isOK<>mrOK then begin
      MessageDlg('ۑ𒆎~܂.',mtError,[mbOK],0);
      exit;
    end;
    assignFile(f,SaveDialog1.Filename);
    {$I-} rewrite(f,1); {$I+};
    if IOResult=0 then begin
      WriteStatus(0,'ݒł...');
      {$I-} BlockWrite(f,ProgramAreas^,size,saved); {$I+}
      if (IOResult<>0) or (saved<>size) then begin
        CloseFile(f);
        MessageDlg('ۑɎs܂.',mtError,[mbOK],0);
      end
      else begin
        CloseFile(f);
        MessageDlg('ɕۑ܂.',mtError,[mbOK],0);
      end;
    end
    else begin
      MessageDlg('t@CJ܂.',mtError,[mbOK],0);
    end;
    WriteStatus(0,'');
    ProgressBar1.Position:=0;
  end;
end;

procedure TForm1.ClearMemClick(Sender: TObject);
begin
  FillChar(ProgramAreas^,sizeof(ProgramAreas^),$FF);
  FillChar(ReadAreas^,sizeof(ReadAreas^),$FF);
  MessageDlg('NA܂.',mtInformation,[mbOK],0);
end;

procedure TForm1.DevCheckClick(Sender: TObject);
begin
  if GetDeviceType(INVALID_HANDLE_VALUE) then begin


  end;
end;

// foCX^Cv擾
function TForm1.GetDeviceType(hDev:THandle):boolean;
var
  isOk:boolean;
  HR:boolean;
  dmy : DWORD;
  isOpened : boolean;
  buff,devname : array [0..255] of byte;
begin
  isOK:=FALSE; isOpened:=FALSE;
  DeviceName:=''; DeviceSize:=-1; DeviceMode:=-1;
  if hDev=INVALID_HANDLE_VALUE  then hDev:=OpenUsbDevice(@WRITER_GUID,@devname)
                                else isOpened:=TRUE;
  if hDev<>INVALID_HANDLE_VALUE then begin
    while TRUE do begin
      if not isOpened then begin
        HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_INITIALIZE,NIL,0,NIL,0,dmy,NIL);
        if not HR then begin
          MessageDlg('Ɏs܂.',mtError,[mbOK],0);
          break;
        end;
        SetRomPower(hDev,TRUE);
      end;
      HR:=DeviceIoControl(hDev,IOCTL_FLASHWR_GETSIGNATURE,@buff,sizeof(buff),@buff,sizeof(buff),dmy,NIL);
      if HR then begin
        if (buff[0]=buff[3]) and (buff[2]=buff[4]) then begin
          // A(Sig=B?)
          if (buff[0]=buff[5]) and (buff[1]=buff[6]) then begin
            // SēŒl$FF̂Ƃ
            // NG;
            DeviceMode:=-1;
          end
          else begin
            // BႤ̂ł΁AB
            DeviceMan:=buff[5];
            DeviceSig:=buff[6];
            DeviceMode:=1;
            isOK:=TRUE;
          end;
        end
        else begin
          // A?
          DeviceMan:=buff[3];
          DeviceSig:=buff[4];
          DeviceMode:=0;
          isOK:=TRUE;
        end;
        if isOK then DeviceName:=GetDeviceString(DeviceMan,DeviceSig,DeviceSize,DeviceVoltage);
        if DeviceName<>'' then begin
          StatusBar1.Panels[1].Text:=DeviceName;
        end;
      end
      else
        DeviceSize:=-1;
      if not isOpened then begin
        SetRomPower(hDev,FALSE);
        Closehandle(hDev);
      end;
      break;
    end;
  end;
  if not isOK then
    MessageDlg('foCXhĂȂT|[gĂ܂.',mtError,[mbOK],0)
  else if DeviceName='' then
    MessageDlg(Format('sȃfoCXłB :%.02X  VOl`: %.02X',[DeviceMan,DeviceSig]),mtWarning,[mbOK],0);
  Result:=isOK;
end;

procedure TForm1.AutoDevTypeClick(Sender: TObject);
begin
  AutoDevType.Checked:=not AutoDevType.Checked;
  isSetAutoType:=AutoDevType.Checked;
end;

procedure TForm1.BPVClick(Sender: TObject);
begin
  BlankProgramVerify;
  ClearStatus;
end;

procedure TForm1.BlankRomClick(Sender: TObject);
begin
  ExecBlankCheck;
  ClearStatus;
end;

procedure TForm1.ProgramRomClick(Sender: TObject);
begin
  BlankProgram;
  ClearStatus;
end;

procedure TForm1.VerifyRomClick(Sender: TObject);
begin
  ExecVerifyRom;
  ClearStatus;
end;

procedure TForm1.ReadRomClick(Sender: TObject);
begin
  ClearMemClick(Sender);
  ExecReadRom;
  ClearStatus;
end;

procedure TForm1.EraseRomClick(Sender: TObject);
begin
  ExecErase;
  ClearStatus;
end;

procedure TForm1.OptimizeWriteClick(Sender: TObject);
begin
  OptimizeWrite.Checked:=not OptimizeWrite.Checked;
  isOptimizeWrite:=OptimizeWrite.Checked;
end;


procedure TForm1.BPCClick(Sender: TObject);
begin
  BlankProgramChecksum;
  ClearStatus;
end;

procedure TForm1.Help1Click(Sender: TObject);
var
  frm : TAboutForm;
begin
  frm:=TAboutForm.Create(Self);
  frm.ShowModal;
  frm.free;
end;

end.
