#include "wdm.h"
#include "stdarg.h"
#include "stdio.h"

#include "usbdi.h"
#include "usbdlib.h"
#include "msm60851.h"

#include "FlashWr.h"
#include "usbdlib.h"



/*++
    IRP_MJ_DEVICE_CONTROL̃fBXpb`[`łB
	[U[[hDeviceIoControl()Ăяo܂B

:

    DeviceObject - MSM60851̃CX^X̋@\foCXIuWFNg(FDO)ւ̃|C^

Ԃl:

    NT Xe[^XR[h

--*/
NTSTATUS
FlashWr_ProcessIOCTL(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    PIO_STACK_LOCATION irpStack;
    PVOID ioBuffer;
    ULONG inputBufferLength;
    ULONG outputBufferLength;
    PDEVICE_EXTENSION deviceExtension;
    ULONG ioControlCode;
    NTSTATUS ntStatus;
    ULONG length;
    PUCHAR pch;
    PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("IRP_MJ_DEVICE_CONTROL\n"));

    FlashWr_IncrementIoCount(DeviceObject);

    //
    // IRP݈̌ʒũ|C^擾Bɂ́At@NVR[hƃp[^܂B
    //

    deviceExtension = DeviceObject->DeviceExtension;
    

	// ȉ̒ʂȂAVIONGXg󂯓邱Ƃ͂ł܂
    //  1) foCX폜Ă 
    //  2) ăX^[gȂ
    //  3) ~Ă
    //  4) [uNGXgɂȂĂ
    //  5) Stop DeviceɂȂĂ
    if ( !FlashWr_CanAcceptIoRequests( DeviceObject ) ) {
        ntStatus = STATUS_DELETE_PENDING;
        Irp->IoStatus.Status = ntStatus;
        Irp->IoStatus.Information = 0;

        IoCompleteRequest( Irp, IO_NO_INCREMENT );

        FlashWr_DecrementIoCount(DeviceObject);                          
        return ntStatus;
    }

    irpStack = IoGetCurrentIrpStackLocation (Irp);

    Irp->IoStatus.Status = STATUS_SUCCESS;
    Irp->IoStatus.Information = 0;

    // Ăяoi[U[jIOobt@̃|C^ƒ擾
    ioBuffer           = Irp->AssociatedIrp.SystemBuffer;
    inputBufferLength  = irpStack->Parameters.DeviceIoControl.InputBufferLength;
    outputBufferLength = irpStack->Parameters.DeviceIoControl.OutputBufferLength;

    ioControlCode = irpStack->Parameters.DeviceIoControl.IoControlCode;

    //
    // [U[[hIOCTL̏
    //

    switch (ioControlCode) {

    case IOCTL_FLASHWR_RESET_PIPE:
        {
            PUSBD_PIPE_INFORMATION pipe;
	        PFILE_OBJECT fileObject;

		    // ReLXg擾ApCvȂΌ
	        fileObject = irpStack->FileObject;

		    pipe = (PUSBD_PIPE_INFORMATION) fileObject->FsContext;    

		    if(pipe == NULL) {
			    // G[B̓pCvł͂Ȃ
	            ntStatus =
		            Irp->IoStatus.Status = STATUS_INVALID_PARAMETER;
		    } else {            
                FlashWr_ResetPipe(DeviceObject, pipe );
            
                ntStatus = Irp->IoStatus.Status = STATUS_SUCCESS;
            }
        }
        break;


     case IOCTL_FLASHWR_GET_CONFIG_DESCRIPTOR:

        //
        // ̂`oh̓RtBO[VfXNv^ƂׂẴGh|CgA
        // уfXNv^̃Rs[Ԃ܂B
        //

        //
        //   - Ȃ
        // o - RtBO[VfXNv^ƃC^[tFCXAGh|CgfXNv^
        //

        pch = (PUCHAR) ioBuffer;

        configurationDescriptor =
            deviceExtension->UsbConfigurationDescriptor;

        if (configurationDescriptor) {
            
            length = configurationDescriptor->wTotalLength;

            RtlCopyMemory(pch,
                          (PUCHAR) configurationDescriptor,
                          length);

            Irp->IoStatus.Information = length;

            ntStatus = Irp->IoStatus.Status = STATUS_SUCCESS;
        }
        else {

            Irp->IoStatus.Information = 0;

            ntStatus = Irp->IoStatus.Status = STATUS_DEVICE_DATA_ERROR;
        }

        break;

     case IOCTL_FLASHWR_RESET_DEVICE:
		ntStatus = FlashWr_ResetDevice( DeviceObject );
        break;               

/////////////////////////////////////

	 case IOCTL_FLASHWR_INITIALIZE:
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,0,0,0,NULL,0);
	    break;

	 case IOCTL_FLASHWR_DISPSTRING:
	// [display string]
	    ntStatus = FlashWr_RequestVendorCmd( DeviceObject,FALSE,1,0,0,(void *)ioBuffer,inputBufferLength);
		break;

	 case IOCTL_FLASHWR_ROMPOWER:
	 // [Power on/off(byte)]
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,2,*(UCHAR *)ioBuffer,0,NULL,0);
	    break;

	 case IOCTL_FLASHWR_GETSIGNATURE:
	 // [Norm(WORD)][A Type(WORD)][Btype(WORD]
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,TRUE,3,0,0,(void *)ioBuffer,7);
        if (ntStatus==STATUS_SUCCESS) {
          Irp->IoStatus.Status = STATUS_SUCCESS;
          Irp->IoStatus.Information = 7;
        } else {
          Irp->IoStatus.Status = STATUS_DEVICE_DATA_ERROR;
          Irp->IoStatus.Information = 0;
        }
		break;

	 case IOCTL_FLASHWR_SETADDRESS:
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,4,*(USHORT *)ioBuffer,0,NULL,0);
	    break;

	 case IOCTL_FLASHWR_CHECKSUM:
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,5,0,0,NULL,0);
		break;

	 case IOCTL_FLASHWR_BLANK:
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,6,0,0,NULL,0);
		break;
	 
	 case IOCTL_FLASHWR_CHIPERASE:
	 // [Erase Type(byte)]
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,7,*(UCHAR *)ioBuffer,0,NULL,0);
		break;

	 case IOCTL_FLASHWR_SECTORERASE:
	 // [Erase Type(byte)] [ Erase Sector Address(Word)]
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,8,*(UCHAR *)ioBuffer,*(USHORT *)((UCHAR *)ioBuffer+1),NULL,0);
		break;
	 
	 case IOCTL_FLASHWR_READ:
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,9,0,0,NULL,0);
		break;

	 case IOCTL_FLASHWR_WRITE:
	 // [Write Type(byte)]
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,FALSE,10,*(UCHAR *)ioBuffer,0,NULL,0);
		break;
	 
	 case IOCTL_FLASHWR_ENQUIRE:
	 // [ Status byte ] [Power Status] [sum(4)]
	    ntStatus = FlashWr_RequestVendorCmd(DeviceObject,TRUE,11,0,0,(void *)ioBuffer,6);
        if (ntStatus==STATUS_SUCCESS) {
          Irp->IoStatus.Status = STATUS_SUCCESS;
          Irp->IoStatus.Information = 6;
        } else {
          Irp->IoStatus.Status = STATUS_DEVICE_DATA_ERROR;
          Irp->IoStatus.Information = 0;
        }
		break;

    default:

        ntStatus =
            Irp->IoStatus.Status = STATUS_INVALID_PARAMETER;
    }

    IoCompleteRequest (Irp,
                       IO_NO_INCREMENT
                       );

    FlashWr_DecrementIoCount(DeviceObject);                       

    return ntStatus;

}




/*++

	|[gXe[^X`FbN܂BOKȂsuccessԂłB
	NgȂ΃Zbgs܂B

:
    DeviceObject - MSM60851̃CX^X̃foCXIuWFNgւ̃|C^
Ԃl:
    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_ResetDevice(
    IN PDEVICE_OBJECT DeviceObject
    )
{
    NTSTATUS ntStatus;
    ULONG portStatus;

    FLASHWR_KdPrint(5,("Enter FlashWr_ResetDevice()\n"));
    
    //
    // |[gԂ`FbNAdisableĂċKvłB
    //
    ntStatus = FlashWr_GetPortStatus(DeviceObject, &portStatus);

    if (NT_SUCCESS(ntStatus) && !(portStatus & USBD_PORT_ENABLED) &&
        portStatus & USBD_PORT_CONNECTED) {
        //
        // |[gdisableԂȂ̂ŁAZbgs
        //
		FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetDevice() will reset\n"));
        ntStatus = FlashWr_ResetParentPort(DeviceObject);
    }
	return ntStatus;
}



/*++
    foCX̃|[gXe[^XԂ܂

Ԃl:
	ȂSTATUS_SUCCESSAȊO STATUS_UNSUCCESSFULԂ܂

--*/
NTSTATUS
FlashWr_GetPortStatus(
    IN PDEVICE_OBJECT DeviceObject,
    IN PULONG PortStatus
    )
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;
    PDEVICE_EXTENSION deviceExtension;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_GetPortStatus\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    *PortStatus = 0;

    //
    // NGXg̔s
    //

    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IoBuildDeviceIoControlRequest̓foCXRg[NGXĝ߂IRPmۂAݒ肵܂
    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_GET_PORT_STATUS,
                deviceExtension->TopOfStackDeviceObject, //^[QbgfoCXAɒʂ̃hCo[̃foCXIuWFNg
                NULL, // o̓obt@Ȃ
                0,
                NULL,
                0,
                TRUE, //  ( IRP_MJ_INTERNAL_DEVICE_CONTROLg )
                &event, // ɃVOiԂɂCxg( ő҂̂ɕKv )
                &ioStatus);

    //
    // sNXhCoĂт܂BXe[^X(PENDING)ԂȂA
    // NGXĝ҂܂B
    //

    // IoGetNextIrpStackLocation͍ʂ̃hCo[ANZXIRP̒̎ɒʂ̃hCo
    // IOX^bNʒuɗ^܂BČĂяo͒ʂ̃hCoANZXZbgAbv܂B
    nextStack = IoGetNextIrpStackLocation(irp);
    FLASHWR_ASSERT(nextStack != NULL);

    nextStack->Parameters.Others.Argument1 = PortStatus;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_GetPortStatus() calling USBD port status api\n"));

    ntStatus = IoCallDriver(deviceExtension->TopOfStackDeviceObject,
                            irp);

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_GetPortStatus() return from IoCallDriver USBD %x\n", ntStatus));

    if (ntStatus == STATUS_PENDING) {

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("Wait for single object\n"));

        status = KeWaitForSingleObject(
                       &event,
                       Suspended,
                       KernelMode,
                       FALSE,
                       NULL);

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_GetPortStatus() Wait for single object, returned %x\n", status));
        
    } else {
        ioStatus.Status = ntStatus;
    }

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_GetPortStatus() Port status = %x\n", *PortStatus));

    //
    // USBD̓G[R[h}bv܂
    //
    ntStatus = ioStatus.Status;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("Exit FlashWr_GetPortStatus (%x)\n", ntStatus));


    return ntStatus;
}


/*++
	e|[gZbg܂B

Ԃl:

    ȂSTATUS_SUCCESSAȊOSTATUS_UNSUCCESSFULԂ܂B

--*/
NTSTATUS
FlashWr_ResetParentPort(
    IN IN PDEVICE_OBJECT DeviceObject
    )
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;
    PDEVICE_EXTENSION deviceExtension;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_ResetParentPort\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    //
    // NGXg𔭍s܂
    //

    KeInitializeEvent(&event, NotificationEvent, FALSE);

    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_RESET_PORT,
                deviceExtension->TopOfStackDeviceObject,
                NULL,
                0,
                NULL,
                0,
                TRUE, // internal ( use IRP_MJ_INTERNAL_DEVICE_CONTROL )
                &event,
                &ioStatus);

    //
    // sNXhCoĂт܂BXe[^X(PENDING)ԂȂA
    // NGXĝ҂܂B
    //

    nextStack = IoGetNextIrpStackLocation(irp);
    FLASHWR_ASSERT(nextStack != NULL);

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetParentPort() calling USBD enable port api\n"));

    ntStatus = IoCallDriver(deviceExtension->TopOfStackDeviceObject,
                            irp);
                            
    FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetParentPort() return from IoCallDriver USBD %x\n", ntStatus));

    if (ntStatus == STATUS_PENDING) {

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetParentPort() Wait for single object\n"));

        status = KeWaitForSingleObject(
                       &event,
                       Suspended,
                       KernelMode,
                       FALSE,
                       NULL);

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetParentPort() Wait for single object, returned %x\n", status));
        
    } else {
        ioStatus.Status = ntStatus;
    }

    //
    // USBD̓G[R[h}bv܂
    //
    ntStatus = ioStatus.Status;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("Exit FlashWr_ResetPort (%x)\n", ntStatus));

    return ntStatus;
}

