#include "wdm.h"
#include "stdarg.h"
#include "stdio.h"

#define DRIVER 

#include "usbdi.h"
#include "usbdlib.h"
#include "msm60851.h"


/*++

Routine Description:

    ̃[`IRP_MJ_READFlashWr_Read()ɂĂяo܂.
    ̃[`IRP_MJ_WRITEFlashWr_Write()ɂĂяo܂.

	ǂݏoA邢͏݂w肳ꂽTCY̗ʂs܂B
	̗ʂdeviceExtension->MaximumTransferSizeɂw肳܂B

:

    DeviceObject - @\foCXIuWFNgiFDOjւ̃|C^
    Irp - IRP_MJ_READ邢IRP_MJ_WRITEւ̃|C^

    Read - TRUEȂǂݏoAFALSEȂ珑݂s܂B


Ԃl:

    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_StagedReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN BOOLEAN Read
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
	NTSTATUS resetPipeStatus;
    PFILE_OBJECT fileObject;
    PIO_STACK_LOCATION irpStack, nextStack;
    PURB urb;
    PIRP irp;
    PMDL mdl; 
    PVOID va;
    CHAR stackSize;
    KIRQL OldIrql;
	BOOLEAN fRes;
    NTSTATUS waitStatus;
    ULONG i, nIrps = 0, totalLength = 0, totalIrpsNeeded, used;
    PUSBD_PIPE_INFORMATION pipeHandle = NULL;
    PDEVICE_EXTENSION deviceExtension = DeviceObject->DeviceExtension;
    PUCHAR pCon =  NULL;
	ULONG ChunkSize = deviceExtension->MaximumTransferSize;
	ULONG arraySize;
    PFLASHWR_RW_CONTEXT context = NULL;

    FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("enter FlashWr_StagedReadWrite()\n"));

    Irp->IoStatus.Information = 0;

	// ȉ̒ʂȂAVIONGXg󂯓邱Ƃ͂ł܂
    //  1) foCX폜Ă 
    //  2) ăX^[gȂ
    //  3) ~Ă
    //  4) [uNGXgɂȂĂ
    //  5) Stop DeviceɂȂĂ
    if ( !FlashWr_CanAcceptIoRequests( DeviceObject ) ) {
        ntStatus = STATUS_DELETE_PENDING;
        Irp->IoStatus.Status = ntStatus;
		FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() can't accept requests, returning STATUS_INSUFFICIENT_RESOURCES\n"));
        IoCompleteRequest (Irp, IO_NO_INCREMENT );
        return ntStatus;
    }


    irpStack = IoGetCurrentIrpStackLocation (Irp);
    fileObject = irpStack->FileObject;

    pipeHandle =  fileObject->FsContext;

    if (!pipeHandle)
    {
       ntStatus = STATUS_INVALID_HANDLE;
	   FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() Rejecting on invalid pipeHandle 0x%x decimal %d\n",pipeHandle, pipeHandle ));
       Irp->IoStatus.Status = ntStatus;
       IoCompleteRequest (Irp, IO_NO_INCREMENT );
       return ntStatus;
    }

    //
    // USBւ̃NGXg䂾˂܂
    //
	FLASHWR_ASSERT( UsbdPipeTypeBulk == pipeHandle->PipeType );


	if ( Irp->MdlAddress )
		totalLength = MmGetMdlByteCount(Irp->MdlAddress);


	FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() totalLength = decimal %d, Irp->MdlAddress = 0x%x\n",totalLength, Irp->MdlAddress ));

    if ( 0 == totalLength ) {
		// 0oCg̓ǂݏAԂ܂B
        ntStatus = STATUS_SUCCESS;
        Irp->IoStatus.Status = ntStatus;
		FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() returning quick success on zero-len read/write request\n"));

        IoCompleteRequest (Irp, IO_NO_INCREMENT );
        return ntStatus;
    }
    

	// tbVC^̃obt@TCY傫H
 	if ( totalLength > FLASHWR_TEST_BOARD_TRANSFER_BUFFER_SIZE )
	{
       ntStatus = STATUS_INVALID_PARAMETER;
	   FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() Rejecting on too large request 0x%x decimal %d\n",totalLength, totalLength ));
       Irp->IoStatus.Status = ntStatus;
       IoCompleteRequest (Irp, IO_NO_INCREMENT );
       return ntStatus;
	}

    // KvIRP̃Xe[W̌vZ
	totalIrpsNeeded =  totalLength / deviceExtension->MaximumTransferSize ;
	if ( totalLength % deviceExtension->MaximumTransferSize )
		totalIrpsNeeded++;


	FLASHWR_ASSERT( !deviceExtension->PendingIoIrps );  // this should have been cleaned up last time
	FLASHWR_ASSERT( !deviceExtension->BaseIrp );  // this should have been cleaned up last time

    used = 0;
	// ^[~l[V̂߁A]vɊmہB
	arraySize =  ( totalIrpsNeeded +1 ) * sizeof(FLASHWR_RW_CONTEXT);

    // ̃Xe[WIRPFLASHWR_RW_CONTEXT\̊̕m
    deviceExtension->PendingIoIrps = FLASHWR_ExAllocatePool(NonPagedPool, arraySize );
    
    if ( !deviceExtension->PendingIoIrps ) {
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
        FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() !deviceExtension->PendingIoIrps STATUS_INSUFFICIENT_RESOURCES\n"));
        Irp->IoStatus.Status = ntStatus;
        IoCompleteRequest (Irp, IO_NO_INCREMENT );
        return ntStatus;
    }

    RtlZeroMemory(deviceExtension->PendingIoIrps, arraySize );

    // ŏ FLASHWR_RW_CONTEXT \̂̃|C^̊m
    pCon =  (PUCHAR) deviceExtension->PendingIoIrps;

    deviceExtension->BaseIrp = Irp; // ꂪIWĩ[U[IRP
    deviceExtension->StagedBytesTransferred = 0;
	deviceExtension->StagedPendingIrpCount = totalIrpsNeeded;

    // ̃NGXg邽߂IRPURB̈A\zKv܂

    while (NT_SUCCESS(ntStatus) ) {
        context =  (PFLASHWR_RW_CONTEXT) pCon;
        irp = NULL;
        urb = NULL;
        mdl = NULL;

        if ( !FlashWr_CanAcceptIoRequests( DeviceObject ) ) {
            // Ȃ̉! ( vO )
            ntStatus = STATUS_DELETE_PENDING;
            Irp->IoStatus.Status = ntStatus;
		    FLASHWR_KdPrint ( DBGLVL_MAXIMUM, ("FlashWr_StagedReadWrite() got sudden remove, breaking out of URB-building loop\n"));
            break;
        }

        stackSize = (CCHAR)(deviceExtension->TopOfStackDeviceObject->StackSize + 1);
        irp = IoAllocateIrp(stackSize, FALSE);
        
        // IWi̓IRPMDLɂ莦ꂽobt@̉zAhX擾܂
        va = MmGetMdlVirtualAddress(Irp->MdlAddress);

        if (irp) {
           // eVIRP͑Ŝ̃obt@܂BAIOʒuIoBuildPartialMdl()
           // oRIOʒu̒ɒP̃`NTCỸZNVɃ}bv܂B
           mdl = IoAllocateMdl(va,
                                totalLength,
                                FALSE,
                                FALSE,
                                irp);
        }                                    
                            
        if (mdl) {        
			// ܂sĂȂ猩
			if( ( used + ChunkSize ) > totalLength  ) {
				// KvȂ΍Ō̓]؂߂
				ChunkSize = totalLength - used;

			}

            // ̃Xe[WIRPIÔ߂Ɏgt[U[obt@̃TuGA}bv܂B
            IoBuildPartialMdl(Irp->MdlAddress, // IWiobt@ɂMDL܂
                                               // ́ATuWɃ}bvĂ܂B
                              mdl,             // mۂꂽ^[Qbgmdl
                              (PUCHAR)va + used, // }bvꂽGẢzAhX̃x[X
                              ChunkSize);      // }bvꂽGÃTCY

            used+=ChunkSize;
                                              
            urb = FlashWr_BuildAsyncRequest(DeviceObject,
                                           irp,
                                           pipeHandle,
                                           Read);
        }
        
        if (urb && irp && mdl) {

            context->Urb = urb;
            context->DeviceObject = DeviceObject;
            context->Irp = irp;
			nIrps++;
        
            // IoGetNextIrpStackLocationIRP̒̎̒ʂI/OX^bNʒuɍʂ̃x
            // hCo[̃ANZX^܂BāAĂяo͒ʂ̃hCoZbgAbv
            // ł܂B
            nextStack = IoGetNextIrpStackLocation(irp);
            FLASHWR_ASSERT(nextStack != NULL);
            FLASHWR_ASSERT(DeviceObject->StackSize>1);

            nextStack->MajorFunction = IRP_MJ_INTERNAL_DEVICE_CONTROL;
            nextStack->Parameters.Others.Argument1 = urb;
            nextStack->Parameters.DeviceIoControl.IoControlCode =
                IOCTL_INTERNAL_USB_SUBMIT_URB;

            IoSetCompletionRoutine(irp,
                    FlashWr_AsyncReadWrite_Complete,
                    context, // [`ɔzvf̃ReLXgʂ܂
                    TRUE,    // ɌĂяo
                    TRUE,    // G[ɌĂяo
                    TRUE);   // IRP̃LZɌĂяo

            FLASHWR_KdPrint ( DBGLVL_MAXIMUM, ("FlashWr_StagedReadWrite() created staged irp #%d %x\n", nIrps, irp));
                                   
			// ׂĂ̖̓ǂݏIRP̔zێ܂B˔IȃfoCXA
			// ̑̃G[ɂ͖mɂLZȂ΂Ȃ܂B
			(( PFLASHWR_RW_CONTEXT) pCon)->Irp = irp;

            FlashWr_IncrementIoCount(DeviceObject);

			ntStatus = IoCallDriver(deviceExtension->TopOfStackDeviceObject,
             (( PFLASHWR_RW_CONTEXT) pCon)->Irp);


        } else {
            ntStatus = STATUS_INSUFFICIENT_RESOURCES;
			FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() Dumped from irp loop on failed Irp or urb allocate\n"));
            break;
        }

        if (used >= totalLength) {
            break;      // I(^^)
        }


        // FLASHWR_RW_CONTEXT\̂
        pCon +=  sizeof(FLASHWR_RW_CONTEXT);

    } // end while


    Irp->IoStatus.Status = ntStatus;

    if (!NT_SUCCESS(ntStatus)) {

        FLASHWR_KdPrint ( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() FAILED, ntStatus = 0x%x\n", ntStatus));

	    // try to reset the pipe on error ( unless device has been suddenly removed )
	    if ( pipeHandle  && FlashWr_CanAcceptIoRequests( DeviceObject ) ) {

		    resetPipeStatus = FlashWr_ResetPipe(DeviceObject, pipeHandle );

		    FLASHWR_KdPrint( DBGLVL_DEFAULT, ("FlashWr_StagedReadWrite() Tried to reset pipe 0x%x, Status = 0x%x\n", pipeHandle, resetPipeStatus));
		    FLASHWR_KdPrintCond ( DBGLVL_DEFAULT, (!NT_SUCCESS(resetPipeStatus)), ("FlashWr_StagedReadWrite() FlashWr_ResetPipe() FAILED\n"));

		    if( !NT_SUCCESS(resetPipeStatus) ) {
			    // pCvZbgłȂAfoCXZbg悤Ƃ( parent port )
			    FLASHWR_KdPrint( DBGLVL_DEFAULT, ("Will try to reset device \n"));

			    resetPipeStatus = FlashWr_ResetDevice(DeviceObject);

			    FLASHWR_KdPrintCond ( DBGLVL_DEFAULT, (!NT_SUCCESS(resetPipeStatus)), ("FlashWr_StagedReadWrite() FlashWr_ResetDevice() FAILED\n"));
		    }
	    }
    } // end, if !NT_SUCCESS( ntStatus )


    if ( 0 == nIrps ) {
        // Xe[WIRPĂȂ烊NGXg邾B
		FLASHWR_KdPrint ( DBGLVL_HIGH, ("FlashWr_StagedReadWrite() 0 irps staged, completing  base IRP now!\n"));
        IoCompleteRequest (Irp, IO_NO_INCREMENT  );
    } else {
		FLASHWR_KdPrint ( DBGLVL_HIGH, ("FlashWr_StagedReadWrite() %d irps staged\n", nIrps));

        if ( deviceExtension->BaseIrp ) {
            //
            // ͂ꂽIRPɖ}[NBŌ̃Xe[WIRPꂽƂɊ
            // ( FlashWr_AsyncReadWrite_Complete() ).
            //
		    FLASHWR_KdPrint ( DBGLVL_HIGH, ("FlashWr_StagedReadWrite(),marking base IRP  0x%x pending!\n", Irp));
            FLASHWR_ASSERT( Irp == deviceExtension->BaseIrp );
            ntStatus = STATUS_PENDING;
            Irp->IoStatus.Status = ntStatus;
            IoMarkIrpPending(Irp);
        } else {
        	// Ŏ擾ȑOɃIWiIRP̂FlashWr_AsyncReadWrite_Complete()ŉ\ƂȂ
			// łAdeviceExtension->BaseIrpNULLoĂB
            ntStatus = STATUS_SUCCESS;
        }
    }

    FLASHWR_KdPrint ( DBGLVL_HIGH, ("FlashWr_StagedReadWrite() StagedReadWrite  ntStatus = 0x%x decimal %d\n", ntStatus, ntStatus));
    FLASHWR_KdPrint ( DBGLVL_HIGH, ("EXIT FlashWr_StagedReadWrite() gExAllocCount = dec %d\n", gExAllocCount ));

    return ntStatus;
}



/*++

Routine Description:

    IRP_MJ_READ邢IRP_MJ_WRITEFlashWr_StageReadWrite()Ă΂

:
    DeviceObject - @\foCXIuWFNg(FDO)ւ̃|C^
    Irp - PdeviceExtension->MaximumTransferSizeIONGXgs
    	  FlashWr_StageReadWrite()̒ł̃hCoɂĊmہAyу}bvꂽXe[WIRPB
    PipeHandle - ǂݏsGh|Cgւ̃nh
    Read - TRUEȂΓǂݍ, FALSEȂΏ

Ԃl:
    ꂽ񓯊URBւ̃|C^( USB̃NGXgubN )

--*/
PURB
FlashWr_BuildAsyncRequest(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PUSBD_PIPE_INFORMATION PipeHandle,
    IN BOOLEAN Read
    )
{
    ULONG siz;
    ULONG length;
    PURB urb = NULL;

    length = MmGetMdlByteCount(Irp->MdlAddress);

    siz = sizeof(struct _URB_BULK_OR_INTERRUPT_TRANSFER);
    urb = FLASHWR_ExAllocatePool(NonPagedPool, siz);

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Enter FlashWr_BuildAsyncRequest() len = 0x%x decimal %d \n siz = 0x%x urb 0x%x\n Pipehandle 0x%x\n", length, length, siz, urb, PipeHandle));

    if (urb) {
        RtlZeroMemory(urb, siz);

        urb->UrbBulkOrInterruptTransfer.Hdr.Length = (USHORT) siz;
        urb->UrbBulkOrInterruptTransfer.Hdr.Function =
                    URB_FUNCTION_BULK_OR_INTERRUPT_TRANSFER;
        urb->UrbBulkOrInterruptTransfer.PipeHandle =
                   PipeHandle->PipeHandle;
        urb->UrbBulkOrInterruptTransfer.TransferFlags =
            Read ? USBD_TRANSFER_DIRECTION_IN : 0;

        // short packet is not treated as an error.
        urb->UrbBulkOrInterruptTransfer.TransferFlags |= 
            USBD_SHORT_TRANSFER_OK;            
                
        //
        // gĂȂNꂽURB
        //
        urb->UrbBulkOrInterruptTransfer.UrbLink = NULL;

        urb->UrbBulkOrInterruptTransfer.TransferBufferMDL =
            Irp->MdlAddress;
        urb->UrbBulkOrInterruptTransfer.TransferBufferLength =
            length;

        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_BuildAsyncRequest() Init async urb Length = 0x%x decimal %d, buf = 0x%x\n",
            urb->UrbBulkOrInterruptTransfer.TransferBufferLength,
            urb->UrbBulkOrInterruptTransfer.TransferBufferLength,
            urb->UrbBulkOrInterruptTransfer.TransferBuffer));
    }

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("exit FlashWr_BuildAsyncRequest\n"));

    return urb;
}


/*++
@Xe[W̓ǂݏIRP̊[`

:

    DeviceObject - ̒ʂ̃hCo[X^bÑfoCX̃foCXIuWFNg

    Irp - IRP

    Context - hCo[`̃ReLXg

Ԃl:
    ֐l͍Ō̏̃Xe[^XłB

--*/
NTSTATUS
FlashWr_AsyncReadWrite_Complete(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    NTSTATUS			ntStatus = STATUS_SUCCESS;
    PURB				urb;
    PFLASHWR_RW_CONTEXT context = Context;
    PIO_STACK_LOCATION	irpStack;
    PDEVICE_OBJECT      deviceObject;
	PDEVICE_EXTENSION   deviceExtension;

	// foCXIuWFNgX^bN̎̒ʂ̃hCoɑ邱ɒʂĂA
	// ReLXgfoCXIuWFNg擾Ȃ΂Ȃ܂BȂȂA
	// FlashWr_StagedReadWrite()IoCallDriverʂČĂ΂邩łB
    deviceObject = context->DeviceObject;
	deviceExtension = deviceObject->DeviceExtension;

    //  ʂ̃hCo iPENDINGjԂÃX^bNʒuɂ}[N
    if ( Irp->PendingReturned ) {  
        IoMarkIrpPending(Irp);
    }

	FLASHWR_ASSERT( deviceExtension->PendingIoIrps );  
	FLASHWR_ASSERT( deviceExtension->BaseIrp );  

	FLASHWR_ASSERT( context->Irp == Irp ); 
    
    urb = context->Urb;

    
    FLASHWR_KdPrint( DBGLVL_MAXIMUM,  ("\n\n ENTER FlashWr_AsyncReadWrite_Complete():  Length 0x%08X decimal %d\n   Status 0x%08X\n",
                     urb->UrbBulkOrInterruptTransfer.TransferBufferLength,
                     urb->UrbBulkOrInterruptTransfer.TransferBufferLength,
                     urb->UrbHeader.Status));

    // Xe[W̖IRP̃JE^Z܂
    deviceExtension->StagedPendingIrpCount--;

    // hCȏŜ̖IRPJE^Z܂
    FlashWr_DecrementIoCount(deviceObject);
    
    // 
    // IoCallDriver͂IRPŌĂ΂܂
    // TransferBufferLengthƂɒURBɃZbg܂B
    //
    Irp->IoStatus.Information =
        urb->UrbBulkOrInterruptTransfer.TransferBufferLength;

    ntStatus = STATUS_MORE_PROCESSING_REQUIRED;

    deviceExtension->StagedBytesTransferred += 
        urb->UrbBulkOrInterruptTransfer.TransferBufferLength; 
    
    FLASHWR_KdPrint ( DBGLVL_MAXIMUM,("FlashWr_AsyncReadWrite_Complete(): Staged Async Completion %d, bytes = %d\n", 
        deviceExtension->StagedPendingIrpCount,
        deviceExtension->StagedBytesTransferred)); 

    IoFreeIrp(context->Irp);
    context->Irp = NULL; 


    if (deviceExtension->StagedPendingIrpCount == 0) {
        
		FLASHWR_KdPrint ( DBGLVL_HIGH,("FlashWr_AsyncReadWrite_Complete(): StagedPendingIrpCount == 0, completeting BaseIrp 0x%x\n    Total bytes xferred = 0x%x, decimal %d\n", deviceExtension->BaseIrp, deviceExtension->StagedBytesTransferred, deviceExtension->StagedBytesTransferred));

        deviceExtension->BaseIrp->IoStatus.Status = STATUS_SUCCESS; 

        deviceExtension->BaseIrp->IoStatus.Information = 
            deviceExtension->StagedBytesTransferred;

        IoCompleteRequest(deviceExtension->BaseIrp,
                          IO_NO_INCREMENT);

        FLASHWR_ExFreePool( deviceExtension->PendingIoIrps ); 
		deviceExtension->PendingIoIrps  = NULL;
		deviceExtension->BaseIrp = NULL;

        // FlashWr_CancelPendingIo()Ă΂ꂽÃCxg͑ҋ@Ă܂B
        KeSetEvent(&deviceExtension->StagingDoneEvent, 1, FALSE);
    }
    FLASHWR_ExFreePool(urb);

    FLASHWR_KdPrint ( DBGLVL_HIGH, ("Exit FlashWr_AsyncReadWrite_Complete() gExAllocCount = dec %d\n", gExAllocCount ));
    FLASHWR_KdPrint ( DBGLVL_MAXIMUM,("Exit FlashWr_AsyncReadWrite_Complete(), ntStatus = 0x%x\n\n",ntStatus )); 
    return ntStatus;
}



/*++
	IRP_MJ_READ̃fBXpb`[`łB
	ReadFile()̓[U[[hŏIIɂɂ܂B

:

    DeviceObject - MSM60851̃CX^X̃foCXIuWFNgւ̃|C^
    IRP - IRP_MJ_READւ̃|C^

Ԃl:

    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_Read(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{

    NTSTATUS ntStatus = FlashWr_StagedReadWrite(DeviceObject,
                                  Irp,
                                  TRUE);	// FALSEȂ珑݁ATRUEȂǂݏo

    return ntStatus;                                  

}

/*++
	IRP_MJ_WRITẼfBXpb`[`łB
	WriteFile()̓[U[[hŏIIɂɂ܂B

:

    DeviceObject - MSM60851̃CX^X̃foCXIuWFNgւ̃|C^
    IRP - IRP_MJ_WRITEւ̃|C^

Ԃl:

    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_Write(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{

    NTSTATUS ntStatus = FlashWr_StagedReadWrite(DeviceObject,
                                  Irp,
                                  FALSE);	// FALSEȂ珑݁ATRUEȂǂݏo

    return ntStatus;                                  

}



/*++
	IRP_MJ_CLOSẼfBXpb`[`łB
	[U[[hCloseHandle()Ăяo͑ΉpCvnh
	t@CuWFNgN[Y܂B

:
    DeviceObject - @\foCXIuWFNgiFDOj
Ԃl:
    NTXe[^XR[h
--*/
NTSTATUS
FlashWr_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    NTSTATUS ntStatus;
	NTSTATUS actStat;
    PFILE_OBJECT fileObject;
    PIO_STACK_LOCATION irpStack;
    PDEVICE_EXTENSION deviceExtension;
    PUSBD_PIPE_INFORMATION pipeHandle = NULL;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("entering FlashWr_Close\n"));

    
    FlashWr_IncrementIoCount(DeviceObject);

    deviceExtension = DeviceObject->DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    fileObject = irpStack->FileObject;

    if (fileObject->FsContext) {
        // pCvnhN[Y܂
        pipeHandle =  fileObject->FsContext;

		if ( pipeHandle->PipeFlags ) { // I[vZbgĂ
			// fꂽȂ
			FLASHWR_KdPrint( DBGLVL_DEFAULT,("closing pipe %x\n", pipeHandle));
			deviceExtension->OpenPipeCount--;
			pipeHandle->PipeFlags = 0;
		}
		else {
			// pCv͂łɃN[YĂBˑRREMOVE_DEVICE󂯎ƂN
			// \܂B
			FLASHWR_ASSERT(  deviceExtension->DeviceRemoved );
			FLASHWR_KdPrint( DBGLVL_DEFAULT,("Pipe %x was already closed \n", pipeHandle));

		}
    }

	FlashWr_DecrementIoCount(DeviceObject);
    Irp->IoStatus.Status = STATUS_SUCCESS;
    Irp->IoStatus.Information = 0;

    ntStatus = Irp->IoStatus.Status;


    IoCompleteRequest (Irp,
                       IO_NO_INCREMENT
                       );
                       
	// Ō̃pCvȂAfoCXp[_E悤Ƃ܂B
	actStat = FlashWr_SelfSuspendOrActivate( DeviceObject, TRUE );

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exit FlashWr_Close OpenPipeCount = decimal %d, status %x\n",deviceExtension->OpenPipeCount, ntStatus));

    return ntStatus;
}


/*++
	IRP_MJ_CREATẼfBXpb`[`łB
	[U[[h̃AvP[V"<name genned fron GUID>.\yy"
	̌`ŊJCreateFile()̌ĂяõGg|CgłB
	ȂAyỹ͓pCvIDłB

:
    DeviceObject - @\foCXIuWFNgiFDOjւ̃|C^
Ԃl:
    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PFILE_OBJECT fileObject;
    PIO_STACK_LOCATION irpStack;
    PDEVICE_EXTENSION deviceExtension;
    ULONG i, nameLen, ix, uval, umultiplier;
	NTSTATUS actStat;
    PUSBD_INTERFACE_INFORMATION interface;
	PUSBD_PIPE_INFORMATION PipeInfo;

    deviceExtension = DeviceObject->DeviceExtension;
    interface = deviceExtension->UsbInterface;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("entering FlashWr_Create\n"));

    FlashWr_IncrementIoCount(DeviceObject);

	// ȉ̒ʂȂAVIONGXg󂯓邱Ƃ͂ł܂
    //  1) foCX폜Ă 
    //  2) ăX^[gȂ
    //  3) ~Ă
    //  4) [uNGXgɂȂĂ
    //  5) Stop DeviceɂȂĂ
    if ( !FlashWr_CanAcceptIoRequests( DeviceObject ) ) {
        ntStatus = STATUS_DELETE_PENDING;
        Irp->IoStatus.Status = ntStatus;
        Irp->IoStatus.Information = 0;

        IoCompleteRequest (Irp,
                           IO_NO_INCREMENT
                          );

        FlashWr_DecrementIoCount(DeviceObject);                          
        
		FLASHWR_KdPrint( DBGLVL_DEFAULT,("ABORTING FlashWr_Create\n"));
        return ntStatus;
    }
    
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    fileObject = irpStack->FileObject;

    // fscontextfoCXɂƂNULLł
    fileObject->FsContext = NULL;
	nameLen = fileObject->FileName.Length;

    if (nameLen != 0) {

		FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_Create fileObject->FileName = %ws\n", fileObject->FileName.Buffer ));

		// pipe#̃I[v̂
		ix = nameLen -1;  // pCv̍Ō̃̕CfbNX

		// Ō̕lłȂ΂Ȃ܂ŌZ
		while( ( (fileObject->FileName.Buffer[ ix ] < (WCHAR) '0') ||
				(fileObject->FileName.Buffer[ ix ] > (WCHAR) '9') ) && ix )
				ix--;  

		FLASHWR_ASSERT( ix ); 
		if (  !ix  )  {  //  t@C͏ȂƂPASCIIlĂ邱
			ntStatus = STATUS_INVALID_PARAMETER;
		} else {

			//
			// ̂w肳ApCvIDɕϊ
			// ANSI ascii 10iOx[X̃pCvԍ
			//
			uval = 0;
			umultiplier = 1;
			// ŏő̗LȐlf
			while( ( (fileObject->FileName.Buffer[ ix ] >= (WCHAR) '0') &&
				(fileObject->FileName.Buffer[ ix ] <= (WCHAR) '9') ) && ix ) {

				uval +=  (umultiplier *
					     (ULONG) (fileObject->FileName.Buffer[ ix ] - (WCHAR) '0'));
				ix--;
				umultiplier *= 10; 
			}

			// Xe[^XĂBL̃[vŐΗǂȂB
			ntStatus = STATUS_INSUFFICIENT_RESOURCES;

			for (i=0; i<interface->NumberOfPipes; i++) {

				PipeInfo =  &interface->Pipes[i]; // PUSBD_PIPE_INFORMATION  PipeInfo;

				// vJĂȂpCv
				if ( ( uval == i) && !PipeInfo->PipeFlags) { // JĂpCvtOZbgĂ
					//
					// ̂
					//
					FLASHWR_KdPrint( DBGLVL_DEFAULT,("open pipe %d\n", uval));
					fileObject->FsContext = PipeInfo;
					PipeInfo->PipeFlags = TRUE; // set flag for opened
					ntStatus = STATUS_SUCCESS;

					deviceExtension->OpenPipeCount++;

					// D0łȂ΁AfoCXp[Abv
					actStat = FlashWr_SelfSuspendOrActivate( DeviceObject, FALSE );
					break;
				}
			}
		}

	} // if ix

    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;


    IoCompleteRequest (Irp,
                       IO_NO_INCREMENT
                       );

    FlashWr_DecrementIoCount(DeviceObject);                               

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exit FlashWr_Create %x\n", ntStatus));


    return ntStatus;
}




/*++
	ˑRIRP_MN_REMOVE_DEVICEŖIOLZ܂B
	̃hCo̓Xe[W̓ǂݏŎȐIRPɂď̍\
	(FLASHWR_RW_CONTEXT)ێĂ܂B
	̃[`͂WQAׂĂ̖IOׂăLZ܂B

:
    DeviceObject - MSM60851̃CX^X̃foCXIuWFNg
Ԃl:
    SLZꂽTRUEAȊO FALSE

--*/
BOOLEAN
FlashWr_CancelPendingIo(
    IN PDEVICE_OBJECT DeviceObject
    )
{
	PDEVICE_EXTENSION deviceExtension = DeviceObject->DeviceExtension;
    PUCHAR pCon =  (PUCHAR) deviceExtension->PendingIoIrps;
	ULONG i = 0;
	PIRP Irp;
	USHORT uDriverCancel = 0;  // iocancelirp()oRăLZꂽ
	BOOLEAN cRes; 
    NTSTATUS ntStatus, waitStatus;

	// ̂̂͂Ȃ
	if ( !deviceExtension->PendingIoIrps )
		return FALSE;


    FLASHWR_KdPrint ( DBGLVL_MAXIMUM, ("enter FlashWr_CancelPendingIo()\n"));


    // FLASHWR_RW_CONTEXTzNULLIRPł̓o^ɂ^[~l[g
	for ( i = 0; ((PFLASHWR_RW_CONTEXT)pCon)->Irp ;  i++ ) {

		Irp = ((PFLASHWR_RW_CONTEXT) pCon)->Irp;
		//
		// IoCallDriver̃NGXgŌĂ΂ꂽƁAIoCancelIrpĂсA
		// [`𐧌䂳
		//
		cRes = IoCancelIrp( Irp );

		FLASHWR_KdPrint ( DBGLVL_MAXIMUM,  ("FlashWr_CancelPendingIo() IoCancelIrp() cRes=%d, IRP 0x%x\n", cRes, Irp));

		// LZĂяosȂ΁A_v
		if ( !cRes )
			break;

        uDriverCancel++; // ȂƂLZstO


        // z̒̎̃ReLXg\̂
        pCon +=  sizeof( FLASHWR_RW_CONTEXT);
    } // end, for


    if ( uDriverCancel && cRes ) {

		// ȂƂLZAׂẴLZȂAɓB
		// FlashWr_AsyncReadWriteComplete()̒ŁAŌ̃LZŃCxg̓Zbĝ҂܂B
	    FLASHWR_KdPrint ( DBGLVL_MAXIMUM, ("FlashWr_CancelPendingIo() before waiting for StagingDoneEvent()\n" ));
        waitStatus = KeWaitForSingleObject(
                       &deviceExtension->StagingDoneEvent,
                       Suspended,
                       KernelMode,
                       FALSE,
                       NULL);
	    FLASHWR_KdPrint ( DBGLVL_MAXIMUM, ("FlashWr_CancelPendingIo() finished waiting for StagingDoneEvent()\n" ));
    }

	FLASHWR_KdPrintCond ( DBGLVL_HIGH, uDriverCancel,
        ("FlashWr_CancelPendingIo() cancelled %d via IoCancelIrp()\n",uDriverCancel));

    return (BOOLEAN) uDriverCancel;                                  

}



/*++
	ˑR̃foCX̏̈ꕔƂČĂ΂܂B
	ׂĂ̊JĂpCv̖̓]LZ܂B
	pCv܂JĂAURB_FUNCTION_ABORT_PIPEUSBDR[܂B
	ɕۑꂽݒ̒̃pCv̓N[YꂽƂ}[Nt܂B

:
    @\foCXIuWFNg(FDO)ւ̃|C^
Ԃl:
    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_AbortPipes(
    IN PDEVICE_OBJECT DeviceObject
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PURB urb;
    PDEVICE_EXTENSION deviceExtension;
	ULONG i;

    PUSBD_INTERFACE_INFORMATION interface;
	PUSBD_PIPE_INFORMATION PipeInfo;

    deviceExtension = DeviceObject->DeviceExtension;
    interface = deviceExtension->UsbInterface;

    for (i=0; i<interface->NumberOfPipes; i++) {

        PipeInfo =  &interface->Pipes[i]; // PUSBD_PIPE_INFORMATION  PipeInfo;

		if ( PipeInfo->PipeFlags ) { // JĂ炱ZbgAN[YĂNA

			FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_AbortPipes() Aborting open  Pipe %d\n", i));

			urb = FLASHWR_ExAllocatePool(NonPagedPool,
								 sizeof(struct _URB_PIPE_REQUEST));

			if (urb) {

				urb->UrbHeader.Length = (USHORT) sizeof (struct _URB_PIPE_REQUEST);
				urb->UrbHeader.Function = URB_FUNCTION_ABORT_PIPE;
				urb->UrbPipeRequest.PipeHandle =
					PipeInfo->PipeHandle;

				ntStatus = FlashWr_CallUSBD(DeviceObject, urb);

				FLASHWR_ExFreePool(urb);

			} else {
				ntStatus = STATUS_INSUFFICIENT_RESOURCES;
				FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_AbortPipes() FAILED urb alloc\n" ));
				break;
			}


			if (!(NT_SUCCESS(ntStatus))) {
				// s_vAEg
#if DBG
				if ( gpDbg )
					gpDbg->PipeErrorCount++;
#endif
				break;
			}
			else {
				PipeInfo->PipeFlags = FALSE; // pCvɃN[Y}[N

				deviceExtension->OpenPipeCount--;
#if DBG
				if ( gpDbg )
					gpDbg->AbortPipeCount++;
#endif


			}

		} // end, if pipe open
	} // end, for all pipes


    return ntStatus;
}



/*++
  foCXGNXeVtO`FbN܂

	ȉ̒ʂȂAVIONGXg󂯓邱Ƃ͂ł܂
     1) foCX폜Ă 
     2) ăX^[gȂ
     3) ~Ă
     4) [uNGXgɂȂĂ
     5) Stop DeviceɂȂĂ

:
    DeviceObject - MSM60851̃CX^X̃foCXIuWFNgւ̃|C^
Ԃl:
    VIONGXg󂯓\ȂTRUEAʖڂȂFALSEԂ
--*/
BOOLEAN
FlashWr_CanAcceptIoRequests(
    IN PDEVICE_OBJECT DeviceObject
    )
{
    PDEVICE_EXTENSION deviceExtension;
	BOOLEAN fCan = FALSE;

    deviceExtension = DeviceObject->DeviceExtension;

	//flag set when processing IRP_MN_REMOVE_DEVICE
    if ( !deviceExtension->DeviceRemoved &&
		 // foCX̓X^[giCl[uԁjĂȂ΂ȂȂ
		 deviceExtension->DeviceStarted &&
 		 // hCoIRP_MN_QUERY_REMOVE_DEVICEɐƂɃtO𗧂Ă
		 !deviceExtension->RemoveDeviceRequested &&
 		 // hCoIRP_MN_QUERY_STOP_DEVICEɐƂɃtO𗧂Ă
		 !deviceExtension->StopDeviceRequested ){
			fCan = TRUE;
	}

    FLASHWR_KdPrintCond( DBGLVL_MAXIMUM, !fCan, ("**** FALSE return from FlashWr_CanAcceptIoRequests()!\n"));

	return fCan;
}

